#ifndef FUNCBASE_H
#define FUNCBASE_H

#include <memory>

class FromRedis;
class ToEQMDataBase;
struct FuncActionInfo;

/**
 * @brief 功能基础类，包含读取Redis数据和写入EQM数据库的功能
 * 
 */
class FuncBase
{

public:
    FuncBase();
    ~FuncBase();

    /* 任务线程 */
    virtual void thread_task() = 0;

    /* 设置功能信息 */
    void setFuncActionInfo(FuncActionInfo* pFuncAct);

protected:
    /* 读取Redis的实例 */
    std::shared_ptr<FromRedis> m_fromRedis = nullptr;
    /* 写入EQM数据库的实例 */
    std::shared_ptr<ToEQMDataBase> m_toEQMDataBase = nullptr;
    /* 线程信息 */
    FuncActionInfo* m_pFuncAct = nullptr;
};


#endif // FUNCBASE_H
